=== scripts/ArchLinux-PKGBUILDs/MFront/PKGBUILD ===
pkgname=mfront-git
pkgver=r1761.fda58ae6
pkgrel=1
pkgdesc='A code generation tool dedicated to material knowledge'
url='http://tfel.sourceforge.net'
arch=('x86_64')
license=('custom')
source=("tfel::git+https://github.com/thelfer/tfel.git")
makedepends=('git')
provides=("${pkgname%-git}")
conflicts=("${pkgname%-git}")
md5sums=('SKIP')

pkgver() {
    cd "$srcdir/tfel"

    # Git, no tags available
    printf "r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

build() {
    cd "$srcdir"
    mkdir -p build
    cd build
    cmake "../tfel" \
        -DCMAKE_BUILD_TYPE=Release \
        -Denable-doxygen-doc=OFF
    make
}

package() {
    cd "$srcdir/build"
    make DESTDIR="$pkgdir" install
}
